; *****************************************************************************
;                    Instalace eskch znak na displej CGA
; *****************************************************************************
code     segment
         assume    cs:code,ds:code

         org       100h
start:   jmp       instal                   ; instalace programu

old10    dd        0                        ; pvodn adresa obsluhy INT 10h
vmod     db        3

int10i:                                   ;* voln pvodn obsluhy INT 10h
         pushf                              ; simulace isntrukce INT xx
         call      dword ptr cs:[old10]     ; nastaven novho videomdu
         ret

int10:                                      ; obsluha displeje INT 10h
         pushf
         or        ah,ah                    ; je nastaven mdu displeje ?
         jz        int103                   ; je nastaven videomdu
         cmp       ah,0fh
         jne       int102
         popf
         call      int10i
         mov       al,cs:[vmod]
         iret

int102:  popf                               ; simulace isntrukce INT xx
         jmp       dword ptr cs:[old10]     ; skok na pvodn obsluhu INT 10h
int103:                                   ;* nastaven eskho videomdu
         mov       cs:[vmod],al
         cmp       al,3
         ja        int102
         add       al,4
         xor       al,1
         cmp       al,7
         jb        int102
         mov       al,6
         jmp       short int102

;
;          popf                               ; nvrat registru pznak
;          call      int10i                   ; nastaven novho videomdu
;
;         push      ax
;         push      bx
;         push      cx
;         push      dx
;         push      si
;         push      di
;         push      bp
;         push      ds
;         push      es
;         push      cs
;         pop       es
;         mov       ax,40h
;         mov       ds,ax                    ; data BIOS
;                                          ;* schova parametr displeje
;         mov       ah,3
;         mov       bh,ds:[62h]              ; aktivn strnka displeje
;         call      int10i                   ; zskn pozice a rozmr kurzoru
;         push      dx                       ; schova pozice kurzoru
;         push      cx                       ; schova velikosti kurzoru
;                                          ;* rozvtven podle md
;         mov       al,ds:[49h]              ; aktivn videomd
;         and       al,7fh
;         cmp       al,3
;         jbe       int107                   ; je textov md - OK (instalace)
;         cmp       al,7
;         je        int107                   ; je MDA md - OK (instalace)
;
;;         cmp       al,15
;;         je        int10a
;;         cmp       al,16
;;         je        int10a
;
;         jmp       int109                   ; neznm videomd
;
;
;;int10a:                                   ;* grafick md 640x350
; ;        mov       ax,1122h
; ;        mov       bl,2                     ; 25 dk
; ;        int       10h                      ; naten font ROM 8x14
; ;
; ;        lea       bp,[kam14x]              ; tabulka font
; ;
; ;        push      cs
; ;        pop       es
; ;
; ;        mov       ax,1121h
; ;        xor       dx,dx
; ;        mov       cx,14                    ; 14 bajt na znak
; ;        mov       bh,14
; ;        mov       bl,2                     ; 25 dk
; ;        call      int10i                   ; naten uivatelskch font
; ;
; ;        lea       bp,[kam14x]              ; tabulka font
; ;        xor       ax,ax
; ;        mov       es,ax
; ;        mov       es:[110h],bp
; ;        mov       es:[112h],cs
; ;
; ;        jmp       short int109             ; nvrat parametr displeje
;
;int107:                                   ;* inicializace textovch font
;
;                                          ;* naten standardnch font
;         mov       ax,1114h                 ; pkaz pro naten font 8x16
;         cmp       byte ptr ds:[85h],16     ; je md 16 linek na znak ?
;         je        int104                   ; je md 16 linek na znak
;         mov       al,12h                   ; pkaz pro naten font 8x8
;         cmp       byte ptr ds:[85h],8      ; je md 8 linek na znak ?
;         je        int104                   ; je md 8 linek na znak
;         dec       al                       ; pkaz pro naten font 8x14
;int104:  xor       bl,bl                    ; blok font 0
;         call      int10i                   ; naten standardnch font
;                                          ;* naten uivatelskch font
;         lea       bp,[kam16]               ; tabulka font 8x16
;         mov       bx,1000h                 ; blok 0, 16 bajt na znak
;         cmp       byte ptr ds:[85h],16     ; je md 16 linek na znak ?
;         je        int108                   ; je md 16 linek na znak
;         lea       bp,[kam8]                ; tabulka font 8x8
;         mov       bh,8                     ; blok 0, 8 bajt na znak
;         cmp       byte ptr ds:[85h],8      ; je md 8 linek na znak ?
;         je        int108                   ; je md 8 linek na znak
;         lea       bp,[kam14]               ; tabulka font 8x14
;         mov       bh,14                    ; blok 0, 14 bajt na znak
;int108:  mov       ax,1110h                 ; pkaz pro naten uiv. font
;         mov       cx,46                    ; poet znak = 46
;         mov       dx,128                   ; offset zatku tabulky = 128
;         call      int10i                   ; naten uivatelskch font
;int109:                                   ;* nvrat parametr displeje
;         pop       cx
;         mov       ah,1
;         call      int10i                   ; nastaven velikosti kurzoru
;         mov       ah,2
;         pop       dx
;         mov       bh,ds:[62h]              ; aktivn strnka displeje
;         call      int10i                   ; nastaven pvodn pozice kurzoru
;
;         pop       es
;         pop       ds
;         pop       bp
;         pop       di
;         pop       si
;         pop       dx
;         pop       cx
;         pop       bx
;         pop       ax
;         iret


kam8x    label     byte

         db        0,0,0,0,0,0,0,0                         ; 0
         db        7eh,0c3h,0a5h,81h,0a5h,99h,0c3h,7eh     ; 1
         db        7eh,0ffh,0dbh,0ffh,0dbh,0e7h,0ffh,7eh   ; 2
         db        0,6ch,0feh,0feh,7ch,38h,10h,0           ; 3
         db        0,10h,38h,7ch,0feh,7ch,38h,10h          ; 4
         db        0,38h,38h,0d6h,0feh,0d6h,10h,38h        ; 5
         db        0,10h,38h,7ch,0feh,0d6h,10h,38h         ; 6
         db        0,0,18h,3ch,3ch,18h,0,0                 ; 7
         db        0ffh,0ffh,0e7h,0c3h,0c3h,0e7h,0ffh,0ffh ; 8
         db        0,3ch,66h,42h,42h,66h,3ch,0             ; 9
         db        0ffh,0c3h,99h,0bdh,0bdh,99h,0c3h,0ffh   ; 10
         db        0fh,7,0fh,7dh,0cch,0cch,0cch,78h        ; 11
         db        3ch,66h,66h,66h,3ch,18h,7eh,18h         ; 12
         db        30h,38h,3ch,34h,30h,0d0h,0f0h,60h       ; 13
         db        3fh,33h,3fh,33h,33h,0ddh,0ffh,66h       ; 14
         db        99h,5ah,24h,0c3h,0c3h,24h,5ah,99h       ; 15
         db        40h,70h,7ch,7eh,7ch,70h,40h,0           ; 16
         db        2h,0eh,3eh,7eh,3eh,0eh,2,0              ; 17
         db        18h,3ch,7eh,18h,18h,7eh,3ch,18h         ; 18
         db        6ch,6ch,6ch,6ch,6ch,0,6ch,0             ; 19
         db        7eh,0f4h,0f4h,74h,34h,34h,34h,0         ; 20
         db        3ch,60h,38h,6ch,6ch,38h,0ch,78h         ; 21  " "
         db        0,0,0,0,7eh,7eh,7eh,0                   ; 22
         db        18h,3ch,7eh,18h,7eh,3ch,18h,7eh         ; 23
         db        18h,3ch,7eh,18h,18h,18h,18h,18h         ; 24
         db        18h,18h,18h,18h,18h,7eh,3ch,18h         ; 25
         db        0,4,6,0ffh,0ffh,6,4,0                   ; 26
         db        0,20h,60h,0ffh,0ffh,60h,20h,0           ; 27
         db        0,60h,60h,60h,60h,7eh,0,0               ; 28
         db        0,24h,66h,0ffh,0ffh,66h,24h,0           ; 29
         db        0,8,1ch,3eh,7fh,7fh,7fh,0               ; 30
         db        0,7fh,7fh,7fh,3eh,1ch,8,0               ; 31
         db        0,0,0,0,0,0,0,0                         ; 32  " "
         db        18h,18h,18h,18h,18h,0,18h,0             ; 33  "!"
         db        6ch,6ch,6ch,0,0,0,0,0                   ; 34  "
         db        6ch,6ch,0feh,6ch,0feh,6ch,6ch,0         ; 35  "#"
         db        18h,3eh,58h,3ch,1ah,7ch,18h,0           ; 36  "$"
         db        0,63h,66h,0ch,18h,33h,63h,0             ; 37  "%"
         db        1ch,36h,1ch,3bh,6eh,66h,3bh,0           ; 38  "&"
         db        18h,18h,30h,0,0,0,0,0                   ; 39  "'"
         db        0ch,18h,30h,30h,30h,18h,0ch,0           ; 40  "("
         db        30h,18h,0ch,0ch,0ch,18h,30h,0           ; 41  ")"
         db        0,66h,3ch,0ffh,3ch,66h,0,0              ; 42  "*"
         db        0,18h,18h,7eh,18h,18h,0,0               ; 43  "+"
         db        0,0,0,0,0,18h,18h,30h                   ; 44  ","
         db        0,0,0,7eh,0,0,0,0                       ; 45  "-"
         db        0,0,0,0,0,18h,18h,0                     ; 46  "."
         db        6h,0ch,18h,30h,60h,0c0h,80h,0           ; 47  "/"
         db        7ch,0c6h,0ceh,0d6h,0e6h,0c6h,7ch,0      ; 48  "0"
         db        18h,38h,18h,18h,18h,18h,18h,0           ; 49  "1"
         db        3ch,66h,6,0ch,18h,30h,7eh,0             ; 50  "2"
         db        3ch,66h,6,1ch,6,66h,3ch,0               ; 51  "3"
         db        1ch,3ch,6ch,0cch,0feh,0ch,0ch,0         ; 52  "4"
         db        7eh,60h,7ch,6,6,66h,3ch,0               ; 53  "5"
         db        3ch,66h,60h,7ch,66h,66h,3ch,0           ; 54  "6"
         db        7eh,6,6,0ch,18h,18h,18h,0               ; 55  "7"
         db        3ch,66h,66h,3ch,66h,66h,3ch,0           ; 56  "8"
         db        3ch,66h,66h,3eh,0ch,18h,30h,0           ; 57  "9"
         db        0,0,18h,18h,0,18h,18h,0                 ; 58  ":"
         db        0,0,18h,18h,0,18h,18h,30h               ; 59  ";"
         db        0ch,18h,30h,60h,30h,18h,0ch,0           ; 60  "<"
         db        0,0,7eh,0,0,7eh,0,0                     ; 61  "="
         db        60h,30h,18h,0ch,18h,30h,60h,0           ; 62  ">"
         db        3ch,66h,6,0ch,18h,0,18h,0               ; 63  "?"
         db        7ch,0c6h,0deh,0deh,0deh,0c0h,7ch,0      ; 64  "@"
         db        38h,6ch,0c6h,0c6h,0feh,0c6h,0c6h,0      ; 65  "A"
         db        0fch,0c6h,0c6h,0fch,0c6h,0c6h,0fch,0    ; 66  "B"
         db        3ch,66h,0c0h,0c0h,0c0h,66h,3ch,0        ; 67  "C"
         db        0f8h,0cch,0c6h,0c6h,0c6h,0cch,0f8h,0    ; 68  "D"
         db        0feh,0c0h,0c0h,0f8h,0c0h,0c0h,0feh,0    ; 69  "E"
         db        0feh,0c0h,0c0h,0f8h,0c0h,0c0h,0c0h,0    ; 70  "F"
         db        3ch,66h,0c0h,0c0h,0ceh,66h,3eh,0        ; 71  "G"
         db        0c6h,0c6h,0c6h,0feh,0c6h,0c6h,0c6h,0    ; 72  "H"
         db        78h,30h,30h,30h,30h,30h,78h,0           ; 73  "I"
         db        6h,6,6,6,0c6h,0c6h,7ch,0                ; 74  "J"
         db        0c6h,0cch,0d8h,0f0h,0d8h,0cch,0c6h,0    ; 75  "K"
         db        0c0h,0c0h,0c0h,0c0h,0c0h,0c0h,0feh,0    ; 76  "L"
         db        0c6h,0eeh,0feh,0d6h,0c6h,0c6h,0c6h,0    ; 77  "M"
         db        0c6h,0e6h,0f6h,0deh,0ceh,0c6h,0c6h,0    ; 78  "N"
         db        38h,6ch,0c6h,0c6h,0c6h,6ch,38h,0        ; 79  "O"
         db        0fch,0c6h,0c6h,0fch,0c0h,0c0h,0c0h,0    ; 80  "P"
         db        38h,6ch,0c6h,0c6h,0dah,6ch,36h,0        ; 81  "Q"
         db        0fch,0c6h,0c6h,0fch,0cch,0c6h,0c6h,0    ; 82  "R"
         db        7ch,0c6h,0c0h,7ch,6,0c6h,7ch,0          ; 83  "S"
         db        0fch,30h,30h,30h,30h,30h,30h,0          ; 84  "T"
         db        0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,7ch,0     ; 85  "U"
         db        0c6h,0c6h,0c6h,0c6h,0c6h,6ch,38h,0      ; 86  "V"
         db        0c6h,0c6h,0c6h,0d6h,0feh,0eeh,0c6h,0    ; 87  "W"
         db        0c6h,0c6h,6ch,38h,6ch,0c6h,0c6h,0       ; 88  "X"
         db        66h,66h,66h,3ch,18h,18h,18h,0           ; 89  "Y"
         db        0feh,6,0ch,18h,30h,60h,0feh,0           ; 90  "Z"
         db        3ch,30h,30h,30h,30h,30h,3ch,0           ; 91  "["
         db        0c0h,60h,30h,18h,0ch,6,2,0              ; 92  "\"
         db        3ch,0ch,0ch,0ch,0ch,0ch,3ch,0           ; 93  "]"
         db        8h,1ch,36h,63h,0,0,0,0                  ; 94  "^"
         db        0,0,0,0,0,0,0,0ffh                      ; 95  "_"
         db        30h,18h,0ch,0,0,0,0,0                   ; 96  "`"
         db        0,0,7ch,6,7eh,0c6h,7eh,0                ; 97  "a"
         db        0c0h,0c0h,0fch,0c6h,0c6h,0c6h,0fch,0    ; 98  "b"
         db        0,0,7ch,0c6h,0c0h,0c6h,7ch,0            ; 99  "c"
         db        6h,6,7eh,0c6h,0c6h,0c6h,7eh,0           ; 100 "d"
         db        0,0,7ch,0c6h,0feh,0c0h,7ch,0            ; 101 "e"
         db        3ch,66h,60h,0f8h,60h,60h,60h,0          ; 102 "f"
         db        0,0,7eh,0c6h,0c6h,7eh,6,0fch            ; 103 "g"
         db        0c0h,0c0h,0fch,0c6h,0c6h,0c6h,0c6h,0    ; 104 "h"
         db        18h,0,18h,18h,18h,18h,18h,0             ; 105 "i"
         db        0ch,0,0ch,0ch,0ch,0ch,0cch,78h          ; 106 "j"
         db        0c0h,0c0h,0c6h,0cch,0f8h,0cch,0c6h,0    ; 107 "k"
         db        18h,18h,18h,18h,18h,18h,18h,0           ; 108 "l"
         db        0,0,6ch,0feh,0d6h,0c6h,0c6h,0           ; 109 "m"
         db        0,0,0fch,0c6h,0c6h,0c6h,0c6h,0          ; 110 "n"
         db        0,0,7ch,0c6h,0c6h,0c6h,7ch,0            ; 111 "o"
         db        0,0,0fch,0c6h,0c6h,0fch,0c0h,0c0h       ; 112 "p"
         db        0,0,7eh,0c6h,0c6h,7eh,6,6               ; 113 "q"
         db        0,0,0fch,0c6h,0c0h,0c0h,0c0h,0          ; 114 "r"
         db        0,0,7ch,0c0h,7ch,6,0fch,0               ; 115 "s"
         db        60h,60h,0fch,60h,60h,66h,3ch,0          ; 116 "t"
         db        0,0,0c6h,0c6h,0c6h,0c6h,7eh,0           ; 117 "u"
         db        0,0,0c6h,0c6h,0c6h,6ch,38h,0            ; 118 "v"
         db        0,0,0c6h,0c6h,0d6h,0feh,6ch,0           ; 119 "w"
         db        0,0,0c6h,6ch,38h,6ch,0c6h,0             ; 120 "x"
         db        0,0,0c6h,0c6h,0c6h,7eh,6,0fch           ; 121 "y"
         db        0,0,7eh,0ch,18h,30h,7eh,0               ; 122 "z"
         db        0eh,18h,18h,70h,18h,18h,0eh,0           ; 123 "{"
         db        18h,18h,18h,0,18h,18h,18h,0             ; 124 "|"
         db        70h,18h,18h,0eh,18h,18h,70h,0           ; 125 "}"
         db        32h,4ch,0,0,0,0,0,0                     ; 126 "~"
         db        0,18h,3ch,66h,0c3h,0c3h,0ffh,0          ; 127 ""


kam8     label     byte                   ;* fonty Kamenickch 8*8

         db        66h,3ch,66h,0c0h,0c0h,66h,3ch,0         ; 128 ""
         db        66h,0,0c6h,0c6h,0c6h,0c6h,7eh,0         ; 129 ""
         db        0ch,18h,7ch,0c6h,0feh,0c0h,7ch,0        ; 130 ""
         db        96h,66h,6,7eh,0c6h,0c6h,7eh,0           ; 131 ""
         db        66h,0,7ch,6,7eh,0c6h,7eh,0              ; 132 ""
         db        0cch,78h,0f8h,0cch,0c6h,0cch,0f8h,0     ; 133 ""
         db        66h,3ch,7eh,18h,18h,18h,18h,0           ; 134 ""
         db        66h,3ch,7ch,0c6h,0c0h,0c6h,7ch,0        ; 135 ""
         db        66h,3ch,7ch,0c6h,0feh,0c0h,7ch,0        ; 136 ""
         db        0cch,78h,0fch,0c0h,0f0h,0c0h,0fch,0     ; 137 ""
         db        0cch,0cch,0d8h,0c0h,0c0h,0c0h,0feh,0    ; 138 ""
         db        0ch,18h,3ch,18h,18h,18h,3ch,0           ; 139 ""
         db        35h,32h,30h,30h,30h,30h,30h,0           ; 140 ""
         db        1bh,1bh,18h,18h,18h,18h,18h,0           ; 141 ""
         db        0c6h,38h,6ch,0c6h,0feh,0c6h,0c6h,0      ; 142 ""
         db        13h,3bh,6ch,0c6h,0feh,0c6h,0c6h,0       ; 143 ""
         db        0ch,18h,7eh,60h,78h,60h,7eh,0           ; 144 ""
         db        66h,3ch,7eh,0ch,18h,30h,7eh,0           ; 145 ""
         db        6ch,0feh,0ch,18h,30h,60h,0feh,0         ; 146 ""
         db        3ch,66h,0,7ch,0c6h,0c6h,7ch,0           ; 147 ""
         db        66h,0,7ch,0c6h,0c6h,0c6h,7ch,0          ; 148 ""
         db        3h,3bh,6ch,0c6h,0c6h,6ch,38h,0          ; 149 ""
         db        3ch,66h,3ch,0c6h,0c6h,0c6h,7eh,0        ; 150 ""
         db        0ch,0dah,0c6h,0c6h,0c6h,0c6h,7ch,0      ; 151 ""
         db        0ch,18h,0c6h,0c6h,0c6h,7eh,6,0fch       ; 152 ""
         db        0c6h,38h,6ch,0c6h,0c6h,6ch,38h,0        ; 153 ""
         db        66h,0,0c6h,0c6h,0c6h,0c6h,7ch,0         ; 154 ""
         db        24h,7eh,0c0h,7ch,6,0c6h,7ch,0           ; 155 ""
         db        0dbh,0ceh,0c0h,0c0h,0c0h,0c0h,0feh,0    ; 156 ""
         db        0ch,5ah,66h,3ch,18h,18h,18h,0           ; 157 ""
         db        0cch,78h,0fch,0c6h,0fch,0c6h,0c6h,0     ; 158 ""
         db        66h,66h,0f4h,60h,60h,66h,3ch,0          ; 159 ""
         db        0ch,18h,7ch,6,7eh,0c6h,7eh,0            ; 160 ""
         db        0ch,18h,0,18h,18h,18h,18h,0             ; 161 ""
         db        0ch,18h,0,7ch,0c6h,0c6h,7ch,0           ; 162 ""
         db        18h,30h,0,0c6h,0c6h,0c6h,7eh,0          ; 163 ""
         db        6ch,38h,0fch,0c6h,0c6h,0c6h,0c6h,0      ; 164 ""
         db        66h,3ch,0e6h,0f6h,0deh,0ceh,0c6h,0      ; 165 ""
         db        18h,0a4h,0dah,0c6h,0c6h,0c6h,7ch,0      ; 166 ""
         db        7ch,82h,38h,6ch,0c6h,6ch,38h,0          ; 167 ""
         db        66h,3ch,7eh,0c0h,7ch,6,0fch,0           ; 168 ""
         db        0cch,78h,0fch,0c6h,0c0h,0c0h,0c0h,0     ; 169 ""
         db        18h,30h,0dch,0e6h,0c0h,0c0h,0c0h,0      ; 170 ""
         db        18h,30h,0fch,0c6h,0fch,0c6h,0c6h,0      ; 171 ""
         db        40h,0c0h,44h,4ch,54h,1eh,4,0            ; 172 ""
         db        3ch,60h,38h,6ch,6ch,38h,0ch,78h         ; 173 ""
         db        0,36h,6ch,0d8h,6ch,36h,0,0              ; 174 ""
         db        0,0d8h,6ch,36h,6ch,0d8h,0,0             ; 175 ""
         db        22h,88h,22h,88h,22h,88h,22h,88h         ; 176 ""
         db        55h,0aah,55h,0aah,55h,0aah,55h,0aah     ; 177 ""
         db        0ddh,77h,0ddh,77h,0ddh,77h,0ddh,77h     ; 178 ""
         db        18h,18h,18h,18h,18h,18h,18h,18h         ; 179 ""
         db        18h,18h,18h,18h,0f8h,18h,18h,18h        ; 180 ""
         db        18h,18h,0f8h,18h,0f8h,18h,18h,18h       ; 181 ""
         db        66h,66h,66h,66h,0e6h,66h,66h,66h        ; 182 ""
         db        0,0,0,0,0feh,66h,66h,66h                ; 183 ""
         db        0,0,0f8h,18h,0f8h,18h,18h,18h           ; 184 ""
         db        66h,66h,0e6h,6,0e6h,66h,66h,66h         ; 185 ""
         db        66h,66h,66h,66h,66h,66h,66h,66h         ; 186 ""
         db        0,0,0feh,6,0e6h,66h,66h,66h             ; 187 ""
         db        66h,66h,0e6h,6,0feh,0,0,0               ; 188 ""
         db        66h,66h,66h,66h,0feh,0,0,0              ; 189 ""
         db        18h,18h,0f8h,18h,0f8h,0,0,0             ; 190 ""
         db        0,0,0,0,0f8h,18h,18h,18h                ; 191 ""
         db        18h,18h,18h,18h,1fh,0,0,0               ; 192 ""
         db        18h,18h,18h,18h,0ffh,0,0,0              ; 193 ""
         db        0,0,0,0,0ffh,18h,18h,18h                ; 194 ""
         db        18h,18h,18h,18h,1fh,18h,18h,18h         ; 195 ""
         db        0,0,0,0,0ffh,0,0,0                      ; 196 ""
         db        18h,18h,18h,18h,0ffh,18h,18h,18h        ; 197 ""
         db        18h,18h,1fh,18h,1fh,18h,18h,18h         ; 198 ""
         db        66h,66h,66h,66h,67h,66h,66h,66h         ; 199 ""
         db        66h,66h,67h,60h,7fh,0,0,0               ; 200 ""
         db        0,0,7fh,60h,67h,66h,66h,66h             ; 201 ""
         db        66h,66h,0e7h,0,0ffh,0,0,0               ; 202 ""
         db        0,0,0ffh,0,0e7h,66h,66h,66h             ; 203 ""
         db        66h,66h,67h,60h,67h,66h,66h,66h         ; 204 ""
         db        0,0,0ffh,0,0ffh,0,0,0                   ; 205 ""
         db        66h,66h,0e7h,0,0e7h,66h,66h,66h         ; 206 ""
         db        18h,18h,0ffh,0,0ffh,0,0,0               ; 207 ""
         db        66h,66h,66h,66h,0ffh,0,0,0              ; 208 ""
         db        0,0,0ffh,0,0ffh,18h,18h,18h             ; 209 ""
         db        0,0,0,0,0ffh,66h,66h,66h                ; 210 ""
         db        66h,66h,66h,66h,7fh,0,0,0               ; 211 ""
         db        18h,18h,1fh,18h,1fh,0,0,0               ; 212 ""
         db        0,0,1fh,18h,1fh,18h,18h,18h             ; 213 ""
         db        0,0,0,0,7fh,66h,66h,66h                 ; 214 ""
         db        66h,66h,66h,66h,0ffh,66h,66h,66h        ; 215 ""
         db        18h,18h,0ffh,18h,0ffh,18h,18h,18h       ; 216 ""
         db        18h,18h,18h,18h,0f8h,0,0,0              ; 217 ""
         db        0,0,0,0,1fh,18h,18h,18h                 ; 218 ""
         db        0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh ; 219 ""
         db        0,0,0,0,0ffh,0ffh,0ffh,0ffh             ; 220 ""
         db        0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h ; 221 ""
         db        0fh,0fh,0fh,0fh,0fh,0fh,0fh,0fh         ; 222 ""
         db        0ffh,0ffh,0ffh,0ffh,0,0,0,0             ; 223 ""
         db        0,0,76h,0dch,0cch,0dch,76h,0            ; 224 ""
         db        3ch,66h,7ch,66h,66h,7ch,60h,60h         ; 225 ""
         db        7eh,66h,60h,60h,60h,60h,60h,0           ; 226 ""
         db        0,0,0feh,6ch,6ch,6ch,66h,0              ; 227 ""
         db        0feh,0c6h,60h,30h,60h,0c6h,0feh,0       ; 228 ""
         db        0,0,0,7eh,0d8h,0d8h,70h,0               ; 229 ""
         db        0,0,66h,66h,66h,7ch,60h,0c0h            ; 230 ""
         db        0,0,7eh,18h,18h,18h,0ch,0               ; 231 ""
         db        7eh,18h,3ch,66h,66h,3ch,18h,7eh         ; 232 ""
         db        38h,6ch,0c6h,0feh,0c6h,6ch,38h,0        ; 233 ""
         db        7ch,0c6h,0c6h,0c6h,0c6h,6ch,0eeh,0      ; 234 ""
         db        3ch,66h,30h,7ch,0c6h,0c6h,7ch,0         ; 235 ""
         db        0,0,66h,0dbh,0dbh,0dbh,66h,0            ; 236 ""
         db        3h,6,3ch,66h,66h,3ch,60h,0c0h           ; 237 ""
         db        1eh,30h,60h,7eh,60h,30h,1eh,0           ; 238 ""
         db        3ch,66h,66h,66h,66h,66h,66h,0           ; 239 ""
         db        0,7eh,0,7eh,0,7eh,0,0                   ; 240 ""
         db        18h,18h,7eh,18h,18h,0,7eh,0             ; 241 ""
         db        30h,18h,0ch,18h,30h,0,7eh,0             ; 242 ""
         db        0ch,18h,30h,18h,0ch,0,7eh,0             ; 243 ""
         db        0eh,1bh,18h,18h,18h,18h,18h,18h         ; 244 ""
         db        18h,18h,18h,18h,18h,18h,0d8h,70h        ; 245 ""
         db        0,18h,0,7eh,0,18h,0,0                   ; 246 ""
         db        0,72h,9ch,0,72h,9ch,0,0                 ; 247 ""
         db        0,3ch,66h,66h,3ch,0,0,0                 ; 248 ""
         db        0,0,0,18h,18h,0,0,0                     ; 249 ""
         db        0,0,0,0,18h,0,0,0                       ; 250 ""
         db        7h,7,0ch,0ch,98h,0d8h,70h,30h           ; 251 ""
         db        78h,6ch,6ch,6ch,6ch,0,0,0               ; 252 ""
         db        38h,6ch,18h,30h,7ch,0,0,0               ; 253 ""
         db        0,0,78h,78h,78h,78h,0,0                 ; 254 ""
         db        0,0,0,0,0,0,0,0                         ; 255

instal:  mov       ah,0fh
         int       10h
         mov       ds:[vmod],al
         cmp       al,7
         je        error
                                          ;* instalace obsluhy INT 10h
         mov       ax,3510h
         int       21h
         mov       word ptr ds:[old10],bx
         mov       word ptr ds:[old10+2],es
         lea       dx,[int10]
         mov       ax,2510h
         int       21h

         lea       dx,[kam8]                ; fonty 8*8
         mov       ax,251fh
         int       21h
                                          ;* nastaven videomdu
         mov       ah,0fh
         int       10h                      ; dotaz na souasn videomd
         xor       ah,ah
         int       10h                      ; nov nastaven videomdu
                                          ;* vodn text, instalace
         mov       ah,9
         lea       dx,[uvtxt]
         int       21h                      ; vodn text
         lea       dx,[instal]              ; dlka rezidentn sti
         int       27h                      ; instalace programu
                                          ;* chyba - nen karta CGA
error:   lea       dx,[errtxt]
         mov       ah,9
         int       21h
         int       20h

errtxt   db        'Nen nainstalovna karta CGA !',13,10,'$'

uvtxt    db        'esk fonty CGA - kd Kamenickch; (c) Miroslav Nmeek'
         db        13,10,'$'

code     ends
         end       start
